﻿package 
{
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.ui.Multitouch;
	import flash.ui.MultitouchInputMode;
	import flash.events.TouchEvent;
	
	/**
	 * ...
	 * @author Abiyasa
	 */
	public class Main extends Sprite 
	{
		[Embed(source='../asset/ball_asset.swf')]
		private var Ball:Class;
		
		private var points:Object = new Object();
		
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			
			// add label
			var text:TextField = new TextField();
			var textFormat:TextFormat = new TextFormat("Verdana", 12, 0x808080);
			text.defaultTextFormat = textFormat;
			text.text = "Just touch and drag. You can use more than one finger. Try it!";
			text.x = 10;
			text.y = 10;
			text.width = 400;
			addChild(text);
			
			// init multi touch
			Multitouch.inputMode = MultitouchInputMode.TOUCH_POINT;
			
			stage.addEventListener(TouchEvent.TOUCH_BEGIN, handleBeginTouch);
			stage.addEventListener(TouchEvent.TOUCH_END, handleEndTouch);
			stage.addEventListener(TouchEvent.TOUCH_MOVE, handleTouchMove);
		}
		
		private function handleBeginTouch(event:TouchEvent):void
		{
			if (points[event.touchPointID] == null)
			{
				var theBall:MovieClip = new Ball();
				theBall.x = event.stageX;
				theBall.y = event.stageY;
				
				// scale the ball, good if you have big finger
				theBall.scaleX = 2;
				theBall.scaleY = 2;
				
				addChild(theBall);	
				points[event.touchPointID] = theBall;
				
				theBall.startTouchDrag(event.touchPointID);
			}
		}
		
		private function handleEndTouch(event:TouchEvent):void
		{
			var theBall:MovieClip = points[event.touchPointID] as MovieClip;
			theBall.stopTouchDrag(event.touchPointID);
			
			removeChild(theBall);
			
			points[event.touchPointID] = null;
		}
		
		private function handleTouchMove(event:TouchEvent):void
		{
			var theBall:MovieClip = points[event.touchPointID] as MovieClip;
			theBall.width = event.sizeX
			theBall.height = event.sizeY;
		}		
	}
	
}